package com.ruoyi.project.hit.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.exception.CustomException;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.project.hit.controller.vo.ListCardUserVo;
import com.ruoyi.project.hit.domain.CardUser;
import com.ruoyi.project.hit.domain.SystemDict;
import com.ruoyi.project.hit.service.CardUserService;
import com.ruoyi.project.hit.mapper.CardUserMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.data.redis.core.TimeoutUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.concurrent.TimeUnit;

/**
* @author HP
* @description 针对表【card_user】的数据库操作Service实现
* @createDate 2024-05-22 22:53:27
*/
@Service
public class CardUserServiceImpl extends ServiceImpl<CardUserMapper, CardUser>
    implements CardUserService{
    @Autowired
    private RedisTemplate redisTemplate;

    @Resource
    private CardUserMapper cardUserMapper;

    @Override
    public Long queryByDictKey(Integer dictKey) {
        LambdaQueryWrapper<CardUser> wrapper=new LambdaQueryWrapper<>();
        wrapper.eq(CardUser::getLevel,dictKey);
        return cardUserMapper.selectCount(wrapper);
    }

    @Override
    public List<HashMap> selectCardUserList(ListCardUserVo listCardUserVo) {
        return cardUserMapper.selectCardUserList(listCardUserVo);
    }

    @Override
    public CardUser login(String userName, String userPass) {
        LambdaQueryWrapper<CardUser> wrapper=new LambdaQueryWrapper<>();
        wrapper.eq(CardUser::getUserName,userName);
        wrapper.eq(CardUser::getUserPass,userPass);
        CardUser cardUser = cardUserMapper.selectOne(wrapper);
        if(StringUtils.isNotNull(cardUser)){
            redisTemplate.opsForValue().set("user_login:"+cardUser.getId(),cardUser, 30, TimeUnit.MINUTES);
            return cardUser;
        }
        throw new CustomException("登录失败");

    }

    @Override
    public boolean weatherLogin(Integer userId) {
        return redisTemplate.hasKey("user_login:"+userId);
    }

    @Override
    public int addCardUser(CardUser cardUser) {
        return cardUserMapper.insert(cardUser);
    }
}




