package com.ruoyi.project.uniapp.controller;

import com.ruoyi.framework.web.controller.BaseController;
import com.ruoyi.framework.web.domain.AjaxResult;
import com.ruoyi.framework.web.page.TableDataInfo;
import com.ruoyi.project.hit.domain.CardGame;
import com.ruoyi.project.hit.domain.CardUser;
import com.ruoyi.project.hit.service.CardGameService;
import com.ruoyi.project.hit.service.CardUserHitService;
import com.ruoyi.project.hit.service.CardUserService;
import com.ruoyi.project.uniapp.controller.vo.CardUserGameVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import javax.xml.crypto.Data;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

@EnableScheduling
@RestController
@RequestMapping("/uniapp/bonus")
public class BonusController extends BaseController {
    @Autowired
    private CardUserService cardUserService;
    @Autowired
    private CardGameService cardGameService;
    @Autowired
    private CardUserHitService cardUserHitService;



    @GetMapping("/showAllCardGame")
    public TableDataInfo showAllCardGame(){
        startPage();
        List<HashMap> list = cardGameService.showAllCardGame();
        return getDataTable(list);
    }

    /**
     * 活动详情
     * @param gameId
     * @return
     */
    @PostMapping("/getGameDetail/{gameId}")
    public AjaxResult getGameDetail(@PathVariable(value = "gameId")Integer gameId){
        return AjaxResult.success(cardGameService.getGameDetail(gameId));
    }

    /**
     * 抽奖业务
     * @param cardUserGameVo
     * @return
     */
    @PostMapping("/getPrizeDraw")
    public AjaxResult getPrizeDraw(@RequestBody CardUserGameVo cardUserGameVo){
        return AjaxResult.success(cardUserHitService.getPrizeDraw(cardUserGameVo));
    }

    /**
     * 活动预热
     */
    @Scheduled(fixedRate = 60000)
    public void preHot(){
        Date now=new Date();
        cardGameService.preHot(now);
    }


}
