package com.ruoyi.project.uniapp.controller;

import com.ruoyi.framework.web.controller.BaseController;
import com.ruoyi.framework.web.domain.AjaxResult;
import com.ruoyi.project.hit.domain.CardGame;
import com.ruoyi.project.hit.service.CardGameService;
import com.ruoyi.project.hit.service.CardSaleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/uniapp/homePage")
public class HomePageController extends BaseController {

    @Autowired
    private CardGameService cardGameService;
    @Autowired
    private CardSaleService cardSaleService;
    /**
     * 主页轮播图
     * @return
     */
    @GetMapping("/carousel")
    public AjaxResult carousel(){
        List<CardGame> carousel = cardGameService.carousel();
        return AjaxResult.success(carousel);
    }

    /**
     * 热度榜单
     * @return
     */
    @GetMapping("/getHotSale")
    public AjaxResult getHotSale(){
        return AjaxResult.success(cardSaleService.getHotSale());
    }

    @GetMapping("/getAllHotSale")
    public AjaxResult getAllHotSale(){
        return AjaxResult.success(cardSaleService.getAllHotSale());
    }

    /**
     * 点击(热度增加)
     * @param id
     * @return
     */
    @PostMapping("/addHotSaleNum/{saleId}")
    public AjaxResult addHotSaleNum(@PathVariable(value = "saleId")Integer id){
        cardSaleService.addHotSaleNum(id);
        return AjaxResult.success();
    }



}
