package com.ruoyi.project.uniapp.controller;

import com.ruoyi.framework.web.controller.BaseController;
import com.ruoyi.framework.web.domain.AjaxResult;
import com.ruoyi.project.hit.domain.CardUser;
import com.ruoyi.project.hit.service.CardUserHitService;
import com.ruoyi.project.hit.service.CardUserService;
import com.ruoyi.project.uniapp.controller.vo.CardUserVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

@RestController
@RequestMapping("/uniapp/personalCenter")
public class PersonalCenterController extends BaseController {

    @Autowired
    private CardUserService cardUserService;
    @Autowired
    private CardUserHitService cardUserHitService;

    @PostMapping("/login")
    public AjaxResult login(@RequestBody @Valid CardUserVo cardUser){
        CardUser user = cardUserService.login(cardUser.getUserName(), cardUser.getUserPass());
        return AjaxResult.success("登录成功",user);
    }

    @PostMapping("/addCardUser")
    public AjaxResult addCardUser(@Valid @RequestBody CardUser cardUser){
        return toAjax(cardUserService.addCardUser(cardUser));
    }

    @GetMapping("/winnerRecord/{userId}")
    public AjaxResult getMyWinnerRecord(@PathVariable(value = "userId")Integer userId){
        return AjaxResult.success(cardUserHitService.winnerRecord(userId));
    }
}
